#ifndef CCUTS_H
#define CCUTS_H

#include <iostream>
#include <list>
#include "Ccut.h"
#include "Cneutral.h"
#include "Csubset.h"
using namespace std;



//declaration of class Ccuts
//-----------------------------------------------------
class Ccuts
{
	public:
		typedef list<Ccut>::iterator iterator;
		typedef list<Ccut>::const_iterator const_iterator;

		explicit Ccuts(pos_int_type n) : _cuts(0), _nb_not_realized_cuts(0) {Csubset::N = n;}
		~Ccuts() {}

		void cuts();
		void realization();
		void betti();
		void rank();
		void sol2();
		void all();
		void vertices();

		int nb_cuts() const {return _cuts.size();}
		int nb_realized_cuts() const {return (_cuts.size() - _nb_not_realized_cuts);}
		int nb_not_realized_cuts() const {return _nb_not_realized_cuts;}

		const_iterator begin() const {return _cuts.begin();}
		const_iterator end() const {return _cuts.end();}
		iterator begin() {return _cuts.begin();}
		iterator end() {return _cuts.end();}

	private:
		list<Ccut> _cuts;
		pos_int_type _nb_not_realized_cuts;
		
		pos_int_type global_count;
	
		Cneutral N;

		void generate();
		void recursive(const Cneutral&);
		bool first_time(const Csubset&, const Cneutral&);

	friend ostream& operator<<(ostream&, const Ccuts&);
};
//-----------------------------------------------------



//global functions and operators
//-----------------------------------------------------
ostream& operator<<(ostream&, const Ccuts&);


#endif
