#ifndef CSOL2
#define CSOL2

#include "basic_math.h"
#include "Csubset.h"
#include <map>
#include <vector>
class Ccut;
class CR2;
class CR3;
ostream& operator<<(ostream& os, const CR2& R2);




class CR2
{
public:
	typedef std::vector<std::pair<pos_int_type,pos_int_type> > container_type;
	typedef container_type::const_iterator const_iterator;
		
	explicit CR2(const Ccut& c);
	~CR2() {}
	
	bool valid_solution(const Cbin_int& b);
	
	const_iterator begin() const {return relations.begin();}
	const_iterator end() const {return relations.end();}
	
	pos_int_type nb_var;

private:
	container_type relations;
	
friend ostream& operator<<(ostream& os, const CR2& R2);
};


ostream& operator<<(ostream& os, const CR2::container_type& rel);


class CR3
{
public:
	typedef vector<vector<pos_int_type> >  container_type;
	typedef container_type::const_iterator const_iterator;
	typedef vector<pos_int_type>::const_iterator sub_const_iterator;
		
	explicit CR3(const Ccut& c);
	~CR3() {}
	
	bool valid_solution(const Cbin_int& b);
	
	bool no_equations;
	
private:
	container_type relations;
};



class Csol2
{
public:
	explicit Csol2(const Ccut& c);
	~Csol2() {}
	
	pos_int_type sol2();
	
private:
	CR2 R2;
	CR3 R3;
	
	bool valid_solution(pos_int_type i);
};



#endif
