#ifndef CSUBSET_H
#define CSUBSET_H

#include <iostream>
#include "basic_math.h"
using namespace std;



//declaration of class Csubset
//------------------------------------------------------
class Csubset
{
	public:
		Csubset() : code(0) {}
		explicit Csubset(pos_int_type c) : code(c) {}
		Csubset(const Csubset& J) : code(J.code) {}
		~Csubset() {}

		bool operator<(const Csubset& J) const {return fpp(N, code, J.code);}
		bool operator==(const Csubset& J) const {return (J.code == code);}
		bool operator!=(const Csubset& J) const {return (J.code != code);}
		Csubset& operator=(const Csubset&);
		Csubset& operator++();
		Csubset operator!() const {return (Csubset(power(2,N) - 1 - code));}

		pos_int_type get_code() const {return code;}
		pos_int_type size() const {return nb_digits(code,2);}
		bool contains(pos_int_type i) const;
		bool contains(const Csubset& J) const {return contains(J.code);}
		bool containsN() const {return (code >= power(2,N-1));}
		
		pos_int_type code;		
		static pos_int_type N;

	private:
		//true if the first int is formally shorter than the second one
		bool fpp(pos_int_type, pos_int_type, pos_int_type) const;

	friend ostream& operator<<(ostream&, const Csubset&);
};
//------------------------------------------------------



//operator overloading for printing
//------------------------------------------------------
ostream& operator<<(ostream&, const Csubset&);
//------------------------------------------------------

#endif
