#ifndef TMATRIX_H
#define TMATRIX_H

#include <iostream>
#include <vector>
using namespace std;



//declaration of template class Tmatrix
//------------------------------------------------------
template<class T>
class Tmatrix
{
	public:
		typedef vector<vector<T> >::iterator iterator;
		typedef vector<vector<T> >::const_iterator const_iterator;
		typedef unsigned long size_type;

		Tmatrix() : M(0,0) {}
		explicit Tmatrix(size_type i, size_type j) : M(i,j) {}
		Tmatrix(const Tmatrix& A) : M(A.M) {}
		explicit Tmatrix(size_type, size_type, const T&);
		~Tmatrix() {}

		
		//basic facilities of the stl
		vector<T>& operator[](size_type i) {return M[i];}
		const vector<T>& operator[](size_type i) const {return M[i];}

		Tmatrix& operator=(const Tmatrix& A) {M = A.M; return (*this);}
		
		vector<T>& front() {return M.back();}
		vector<T>& back() {return M.back();}
		
		size_type size() const {return M.size();}
		
		iterator erase(iterator i) {return M.erase(i);}

		void clear() {M.clear();}

		iterator begin() {return M.begin();}
		iterator end() {return M.end();}

		const_iterator begin() const {return M.begin();}
		const_iterator end() const {return M.end();} 


		//advanced features
		void pivot(size_type, size_type);
		void resize(size_type, size_type);

	private:
		vector<vector<T> > M;
};
//------------------------------------------------------



//operator overloading for printing
//------------------------------------------------------
template<class T>
ostream& operator<<(ostream&, const Tmatrix<T>&);

template<class T>
ostream& operator<<(ostream&, const vector<T>&);
//------------------------------------------------------



#include "../src/Tmatrix.tcc"

#endif
