#ifndef BASIC_MATH_H
#define BASIC_MATH_H

#include <vector>
#include <iostream>
#include "Tmatrix.h"
using namespace std;



//declaration of global types and constants
//------------------------------------------------------
typedef double real_type;
typedef long int_type;
typedef unsigned long pos_int_type;

typedef vector<real_type> real_vector_type;
typedef vector<int_type> int_vector_type;
typedef vector<pos_int_type> pos_int_vector_type;

typedef Tmatrix<real_type> real_matrix_type;

const double EPS(0.000001);
//------------------------------------------------------



//declaration of class Cbin_int - this represents
//an int in base 2 - maybe can be done better...
//and this is not safe !!!
//------------------------------------------------------
class Cbin_int;
ostream& operator<<(ostream& os, const Cbin_int& b);

class Cbin_int
{
public:
	typedef std::vector<pos_int_type> container_type;
	typedef container_type::const_iterator const_iterator;
	typedef container_type::iterator iterator;
		
	Cbin_int(pos_int_type i,pos_int_type size);
	~Cbin_int() {}

	pos_int_type operator[](pos_int_type i) const {return bin_rep[bin_rep.size()-i-1];}
	
	const_iterator begin() const {return bin_rep.begin();}
	const_iterator end() const {return bin_rep.end();}
	iterator begin() {return bin_rep.begin();}
	iterator end() {return bin_rep.end();}

private:		
	container_type bin_rep;

friend ostream& operator<<(ostream& os, const Cbin_int& b);
};
//------------------------------------------------------



//declaration of global functions
//------------------------------------------------------
//returns a^b
pos_int_type power(pos_int_type a, pos_int_type b);

//returns the number of digits of n in the base b
//that is not counting 0 !!!
pos_int_type nb_digits(pos_int_type n, pos_int_type b);
//------------------------------------------------------

#endif
