#ifndef BASIC_OUTPUT_H
#define BASIC_OUTPUT_H

#include <iostream>
#include <fstream>
#include <string>
using namespace std;

//definition of the directory path for files
/*
#define RES_VERTICES_DIR "/polygons/results/chambers/h-rep/"
#define RES_CUTS_DIR "/polygons/results/cuts/"
#define RES_REALIZATION_DIR "/polygons/results/realizations/"
#define RES_BETTI_DIR "/polygons/results/betti/"
#define RES_RANK_DIR "/polygons/results/rank/"
#define RES_SOL2_DIR "/polygons/results/sol2/"
#define RES_ALL_DIR "/polygons/results/all/"

#define RES_CUTS_FILE "cuts_"
#define RES_REALIZATION_FILE "realizations_"
#define RES_BETTI_FILE "betti_"
#define RES_RANK_FILE "rank_"
#define RES_SOL2_FILE "sol2_"
#define RES_ALL_FILE "all_"
*/

const string RES_CUTS_FILE("cuts_");
const string RES_REALIZATION_FILE("realizations_");
const string RES_BETTI_FILE("betti_");
const string RES_RANK_FILE("rank_");
const string RES_SOL2_FILE("sol2_");
const string RES_ALL_FILE("all_");



class C_output
{
	public:
		C_output() : ostream_ptr(&cout), ofstream_ptr(0), type(TERMINAL) {}
		~C_output();	
			
		template <class T>
		C_output& operator<<(const T&);
		C_output& operator<<(C_output& (*pf)(C_output&)) {return (*pf)(*this);}

		C_output& terminal();
		C_output& file(const string&);

	private:
		ostream* ostream_ptr;
		ofstream* ofstream_ptr;
	
		enum output_type {TERMINAL, FILE};
		output_type type;
		
		void close_file();

	friend C_output& endl(C_output&);
};



template <class T>
C_output& C_output::operator<<(const T& value)
{
	switch(type)
	{
		case TERMINAL :
			(*ostream_ptr) << value;
			break;
			
		case FILE :
			(*ofstream_ptr) << value;
			break;
	}

	return *this;
};



C_output& endl(C_output&);

		

//global variable that works like cout
extern C_output output;


#endif
