#ifndef LINEAR_PROGRAMMING_H
#define LINEAR_PROGRAMMING_H

#include <string>
#include "basic_math.h"
using namespace std;



//declaration of namespace lp
//-----------------------------------------------------
namespace lp
{
	//variables
	extern real_matrix_type A;
	extern real_vector_type b;
	extern real_vector_type c;

	//functions
	void simplex();
	
	const real_vector_type& results();
	const real_type& max();

	void print_tableau();
};



enum lp_state_type {OPTIMAL, UNBOUNDED, NOT_FEASIBLE, INPUT_VARIABLES, CRITICAL};

class Clp_error
{
	public:
		explicit Clp_error(const lp_state_type& t) : state(t), msg("") {}
		explicit Clp_error(const lp_state_type& t, const string& s) : state(t), msg(s) {}
		~Clp_error() {}

		lp_state_type state;
		string msg;
};

#endif
