#include "Ccuts.h"
#include "Ccut.h"
#include "Cneutral.h"
#include "basic_output.h"



void Ccuts::generate()
{
	global_count = 0;
	if(!_cuts.empty()) {_cuts.clear();}
	N.initialize(Csubset::N);
	recursive(N);
}



void Ccuts::recursive(const Cneutral& N1)
{	
	++global_count;
	
	/*
	//debug test - remove later
	//output << (Ccut)N1.get_constraints() << endl;
	
	if(global_count == 1) {output << global_count << endl;}
	if(global_count == 10) {output << global_count << endl;}
	if(global_count == 100) {output << global_count << endl;}
	if(global_count == 1000) {output << global_count << endl;}
	if(global_count == 10000) {output << global_count << endl;}
	if(global_count == 100000) {output << global_count << endl;}
	if(global_count == 1000000) {output << global_count << endl;}
	if(global_count == 10000000) {output << global_count << endl;}
	if(global_count == 100000000) {output << global_count << endl;}
	if(global_count == 1000000000) {output << global_count << endl;}
	if(global_count == 10000000000) {output << global_count << endl;}
	*/

	_cuts.push_back(Ccut(N1.get_constraints()));
	Cneutral::const_iterator i(N1.begin());
	Cneutral::const_iterator ii(N1.end());
	while(i != ii)
	{
		if(first_time(*i,N1))
		{
			recursive(N1.add_constraints(*i));
		}
		++(++i);
	}
}



bool Ccuts::first_time(const Csubset& J, const Cneutral& N)
{
	Cneutral::const_iterator i(N.get_constraints().begin());
	Cneutral::const_iterator ii(N.get_constraints().end());
	while((i != ii) && (J.get_code() > (*i).get_code()))
	{
		++i;
	}

	if(i == ii) {return true;}
	else {return false;}
}



void Ccuts::cuts()
{
	if(_cuts.empty()) {generate();}
	
	//debug test...
	//output << "Global count " << global_count << endl;
	
	for(iterator i(++begin()); i != end(); ++i)
	{
		output << i->print(CUT) << endl;
		i->clear();
	}
}



void Ccuts::realization()
{
	if(_cuts.empty()) {generate();}
	
	_nb_not_realized_cuts = 0;

	for(iterator i(++_cuts.begin()); i!= _cuts.end(); ++i)
	{
		if(!(i->realize()))
		{
			++_nb_not_realized_cuts;
		}
		output << i->print(REALIZATION) << endl;
		i->clear();
	}
}



void Ccuts::betti()
{
	if(_cuts.empty()) {generate();}
	
	for(iterator i(++begin()); i != end(); ++i)
	{
		i->betti();
		output << i->print(BETTI) << endl;
		i->clear();
	}
}



void Ccuts::rank()
{
	if(_cuts.empty()) {generate();}
	
	for(iterator i(++begin()); i != end(); ++i)
	{
		i->rank();
		output << i->print(RANK) << endl;
		i->clear();
	}
}



void Ccuts::sol2()
{
	if(_cuts.empty()) {generate();}
	
	for(iterator i(++begin()); i != end(); ++i)
	{
		i->sol2();
		output << i->print(SOL2) << endl;
		i->clear();
	}
}



void Ccuts::all()
{
	if(_cuts.empty()) {generate();}
	
	for(iterator i(++begin()); i != end(); ++i)
	{
		i->rank();
		i->realize();
		i->betti();
		i->sol2();
		output << i->print(ALL) << endl;
		i->clear();
	}
}
		


void Ccuts::vertices()
{
	if(_cuts.empty()) {generate();}
	
	for(iterator i(++_cuts.begin()); i!= _cuts.end(); ++i)
	{
		i->vertices();
		i->clear();
	}
}



//global functions and operators
//-----------------------------------------------------	
ostream& operator<<(ostream& o, const Ccuts& C)
{
	//o << endl << "The set of cuts for n = " << Csubset::N << endl;
	//o << "-------------------------------------------------" << endl;
	Ccuts::const_iterator i(C.begin());
	Ccuts::const_iterator ii(C.end());
	while(i != ii)
	{
		o << *(i++) << endl;
	}

	return o;
}

