#include <functional>
#include "Cneutral.h"
#include "Csubsets.h"
#include "Csubset.h"



void Cneutral::initialize(const int& n)
{
	elements.clear();
	constraints.clear();

	Csubset::N = n;

	Csubset i(power(2, (n - 1)));
	Csubset ii(power(2, n));
	Csubset _i;

	while(i != ii)
	{
		_i = !i;
		//_i = (power(2, n) - 1 - i);
		if(!(i < _i) && !(_i < i))
		{
			elements.push_back(i);
			elements.push_back(_i);
		}
		//if((!F_fpp(n, i, _i)) && (!F_fpp(n, _i ,i)))
		//{
		//	elements.push_back(Csubset(i));
		//	elements.push_back(Csubset(_i));
		//}
		++i;
	}


	//this is to add the empty set...
	//constraints.push_back(Csubset(n,0));
}



//predicate class for method 'add_constraints'
		class Cremovable : public unary_function<Csubset,bool>
		{
			public:
				explicit Cremovable(const Csubset& J) : newConstraint(J) {}
				bool operator() (const Csubset& aNeutralElement) const
				{
					Csubset _newConstraint(!newConstraint);
					return ((aNeutralElement < newConstraint) || //
							(aNeutralElement < _newConstraint) || //
							(newConstraint < aNeutralElement) || //
							(_newConstraint < aNeutralElement));

					//possibly not very optimzed; useless to create a new Csubset element
					//with the ! operator...
				}

			private:
				const Csubset& newConstraint;
		};
		
		
		
Cneutral Cneutral::add_constraints(const Csubset& J) const
{
	Cneutral N((*this));
	N.constraints.push_back(J);
	N.elements.remove_if(Cremovable(J));

	return N;			
}



//ostream& operator<<(ostream& o, const Cneutral& N)
//{
//	Cneutral::const_iterator i(N.begin());
//	Cneutral::const_iterator ii(N.end());
//	while(i != ii)
//	{
//		o << *(i++) << endl;
//	}
//	
//	return o;
//}
