#include <cstdlib>
#include "Csubset.h"
#include "basic_output.h"



Csubset& Csubset::operator=(const Csubset& J)
{
	code = J.code;
	return (*this);
}



Csubset& Csubset::operator++()
{
	++code;
	return (*this);
}



bool Csubset::contains(pos_int_type other_code) const
{
	if(other_code > code) {return false;}
	if(other_code == code) {return true;}

	pos_int_type a(code);
	pos_int_type p(0);
	
	
	
	for(pos_int_type i(1); i <= N; ++i)
	{
		//output << "passage num " << i << endl;
		
		Csubset j1(a);
		Csubset j2(other_code);
		Cbin_int jj1(a,N);
		Cbin_int jj2(other_code,N);
		
		//output << "elements are " << j1 << " and " << j2 << endl;
		//output << "in base 2 " << jj1 << " and " << jj2 << endl;
		
		p = power(2,N - i);
		
		//output << "power " << p << endl;
		
		//output << "les div donnent pour " << a << "  " << div(a,p).quot << " et pour " << other_code << "  " << div(other_code,p).quot << endl;
		
		if(div(a,p).quot == 0)
		{
			if(div(other_code,p).quot == 1)
			{
				return false;
			}
			//a = a - p;
			//other_code = other_code - p;
		}
		else
		{
			if(div(other_code,p).quot == 1)
			{
				other_code = other_code - p;
			}
			a = a - p;
		}
	}
	
	return true;
}



bool Csubset::fpp(pos_int_type n, pos_int_type j1, pos_int_type j2) const
{
	//throw an exception if j1 != j2?
	if (j1 > j2) {return false;}
	else
	{
		int_type m1((div(j1, power(2,(n - 1))).quot));
		int_type m2((div(j2, power(2,(n - 1))).quot));
		pos_int_type i(1);

		while((m1 <= m2) && (i < n))
		{
			++i;
			m1 = m1 + div(div(j1, power(2,(n - i))).quot, 2).rem;
			m2 = m2 + div(div(j2, power(2,(n - i))).quot, 2).rem;
		}
		return ((i == n) && (m1 <= m2));
	}
};



ostream& operator<<(ostream& o, const Csubset& J)
{
	real_vector_type A(J.N);
	int j(J.N - 1);
	int x(J.code);
	int y;

	while(j != -1)
	{
		y = power(2,j);
		if(div(x,y).quot == 0)
		{
			A[j] = -1;
		}
		else
		{
			A[j] = 1;
			x = x - y;
		}
		j--;
	}		
	
	//o << "{ ";
	for(int i(A.size() - 1); i > -1; i--)
	{
		if(A[i] == 1)
		{
			o << (i + 1) << "";
		}
	}
	//o << "}";

	return o;
}



//instanciation of static variables
//------------------------------------------------------------------------
pos_int_type Csubset::N(0);
