#include "basic_math.h"
#include "assert.h"
#include "basic_output.h"



Cbin_int::Cbin_int(pos_int_type anInt,pos_int_type k) : bin_rep(k)
{
//	output << "--- ctor Cbin_int, int:" << anInt << " length:" << bin_rep.size() << endl;
	for(iterator i(begin()); i != end(); ++i)
	{
		--k;
		*i = div(anInt,power(2,k)).quot;
		if(*i == 1) {anInt = anInt - power(2,k);}
	}
}



ostream& operator<<(ostream& os, const Cbin_int& b)
{
	for(Cbin_int::const_iterator i(b.begin()); i != b.end(); ++i)
	{
		os << *i;
	}
	
	return os;
}



pos_int_type power(pos_int_type a, pos_int_type b)
{
	assert(b >= 0);
	assert(a >= 0);

	pos_int_type p(1);
	//assert that p is smaller than the unsigned long limit ???
	for (pos_int_type i(1); i <= b; ++i) {p *= a;}
	return p;
}



pos_int_type nb_digits(pos_int_type n, pos_int_type base)
{		
	int_type p(0);
	pos_int_type nb_dig(0), q(0), b(0);
	
	while(power(base,p) <= n) {++p;}
	--p;
	
	while(p != -1)
	{
		b = power(base,p);
		q = div(n,b).quot;
		if(q != 0) {++nb_dig;}
		
		n = n - (q * b);
		--p;
	}

	return nb_dig;
}
