#include <vector>
#include <iostream>
#include <time.h>
#include <string>
#include "cuts.h"
#include "Ccuts_error.h"
#include "linear_programming.h"
using namespace std;



int main()
{
	cout.precision(4);
	
	cout << endl << "CONCERNING THE CLASSIFICATION OF POLYGON SPACES" << endl << endl;

	time_t t0, t1;
	bool quit(false);
	string choice;
	string _n;
	int n(0);
	
	try
	{
		while(!quit)
		{
			cout << "Choose action" << endl;
			cout << "(a) All\n"
				<< "(b) Betti numbers\n"
				<<	"(c) Cuts\n"
				<< "(R) Rank\n"
				<< "(r) Realization\n"
//				<< "(v) Vertices\n"
				<<	"(s) Sol2\n"
				<< "(q) Quit" << endl;
			cin >> choice;
			
			if(choice.size() == 1)
			{
				if(choice[0] == 'q')
				{
					quit = true;
				}
				else if(choice[0] == 'c' || choice[0] == 'r' || choice[0] == 'v' || //
					choice[0] == 'b' || choice[0] == 'a' || choice[0] == 'R' || choice[0] == 's')
				{	
					cout << "And now choose n (4-9)" << endl;
					cin >> _n;
		
					n = atoi(_n.c_str());
				
					if((n > 3) && (n < 10))
					{
						t0 = time(0);
					
						switch(choice[0])
						{
							case 'c' :
								list_cuts(n);
								break;
							case 'r' :
								list_realizations(n);
								break;
//							case 'v' :
//								list_vertices(n);
//								break;
							case 'b' :
								list_betti(n);
								break;
							case 'a' :
								list_all(n);
								break;
							case 'R' :
								list_rank(n);
								break;
							case 's' :
								list_sol2(n);
								break;
								
						}
				
						t1 = time(0);
						cout << endl << "Total calculation time: " << difftime(t1, t0) << " seconds" << endl;
						cout << "--------------------------------------------" << endl << endl;
					}
				}
			}
		}
	}
	catch(Ccuts_error e)
	{
		cout << e.msg << endl;
	}
	catch(Clp_error e)
	{
		cout << e.state << "  " << e.msg << endl;
	}
	catch(...)
	{
		cout << "Oooops..." << endl;
	}

	return 0;
}

















/*


	C_vector c(3);
	C_vector b(4);
	C_matrix A(4,3);

	c[0] = 5;
	c[1] = 5;
	c[2] = 3;

	b[0] = 3;
	b[1] = 2;
	b[2] = 4;
	b[3] = 2;

	A[0][0] = 1; A[0][1] = 3; A[0][2] = 1;
	A[1][0] = -1; A[1][1] = 0; A[1][2] = 3;
	A[2][0] = 2; A[2][1] = -1; A[2][2] = 2;
	A[3][0] = 2; A[3][1] = 3; A[3][2] = -1;

	try
	{
		C_lp P(A,b,c);
		P.simplex();
	}
	catch(C_lp_error e)
	{
		cout << "State of problem is: " << e.state << e.msg << endl;
	}








	try
	{
		C_subset A(8,152);
		C_subset B(8,165);
		C_subset C(8,195);
		C_subsets S;
		S.push_back(A);
		S.push_back(B);
		S.push_back(C);
		
		C_subset D(8,152);
		C_subset E(8,197);
		C_subsets T;
		T.push_back(D);
		T.push_back(E);
		
		C_cuts c8(8);
		c8.generate();

		c8.realize(S);
		c8.realize(T);
	}














while(!quit)
		{
			cout << "Enter the 'n' for the realization of Pol(n)" << endl;
			cout << "Or enter '0' if you desire to quit." << endl;
			cin >> n;

			if(n == 0)
			{
				quit = true;
			}
			else
			{
				if(n > 9)
				{
					cout << "This will take too much time." << endl;
					cout << "--------------------------------------------" << endl << endl;
				}
				else
				{
					if(n > 0)
					{
						time_t t0(time(0));
	
						C_cuts C(n);
						C.generate();
						cout << endl << "--------------------------------------------" << endl;
						cout << "Number of elements in C" << n << ":  " << C.nbElements() << endl << endl;
						C.realization();

						cout << "Number of realized cuts in C" << n << ": " << '\t' << '\t' << C.nb_realized << endl;
						cout << "Number of not realized cuts in C" << n << ": " << '\t' << C.nb_not_realized << endl;
						
						time_t t1(time(0));
						float d(difftime(t1, t0));
						cout << endl << "Total calculation time: " << d << " seconds" << endl;
						cout << "--------------------------------------------" << endl << endl;
					}
					else
					{
						cout << "Not a good input. Try again." << endl;
						cout << "--------------------------------------------" << endl << endl;
					}
				}
			}
		}
		cout << "Hope to see you soon." << endl;
		cout << "--------------------------------------------" << endl << endl;
















	//C_cuts c5(5);
	//c5.generate();
	//cout << "Number of elements in C5:  " << c5.nbElements() << endl << endl;
	//c5.realization();
	//cout << "Number of realized cuts in C5: " << '\t' << '\t' << c5.nb_realized << endl;
	//cout << "Number of not realized cuts in C5: " << '\t' << c5.nb_not_realized << endl;

	//cout << "------------------------------------------------" << endl << endl;
	
	//C_cuts c6(6);
	//c6.generate();
	//cout << "Number of elements in C6:  " << '\t' << '\t' << c6.nbElements() << endl;
	//c6.realization();
	//cout << "Number of realized cuts in C6: " << '\t' << '\t' << c6.nb_realized << endl;
	//cout << "Number of not realized cuts in C6: " << '\t' << c6.nb_not_realized << endl;	

	//cout << "------------------------------------------------" << endl << endl;

	//C_cuts c7(7);
	//c7.generate();
	//cout << "Number of elements in C7:  " << '\t' << '\t' << c7.nbElements() << endl;
	//c7.realization();
	//cout << "Number of realized cuts in C7: " << '\t' << '\t' << c7.nb_realized << endl;
	//cout << "Number of not realized cuts in C7: " << '\t' << c7.nb_not_realized << endl;

	//cout << "------------------------------------------------" << endl << endl;
	
	//C_cuts c8(8);
	//c8.generate();
	//cout << "Number of elements in C8:  " << '\t' << '\t' << c8.nbElements() << endl;
	//c8.realization();
	//cout << "Number of realized cuts in C8: " << '\t' << '\t' << c8.nb_realized << endl;
	//cout << "Number of not realized cuts in C8: " << '\t' << c8.nb_not_realized << endl;
	
	//cout << endl;cout << "------------------------------------------------" << endl << endl;

	//C_cuts c9(9);
	//c9.generate();
	//cout << "Number of elements in C9:  " << '\t' << '\t' << c9.nbElements() << endl;
	//c9.realization();
	//cout << "Number of realized cuts in C9: " << '\t' << '\t' << c9.nb_realized << endl;
	//cout << "Number of not realized cuts in C9: " << '\t' << c9.nb_not_realized << endl;


























	C_matrix A(4,3);
	C_vector b(4);
	C_vector c(3);
	
	A[0][0] = 1; A[0][1] = 2; A[0][2] = 1;
	A[1][0] = -1; A[1][1] = -2; A[1][2] = -1;
	A[2][0] = 3; A[2][1] = -2; A[2][2] = 3;
	A[3][0] = -3; A[3][1] = 2; A[3][2] = -3;
	
	b[0] = 5;
	b[1] = -5;
	b[2] = 2;
	b[3] = -2;
	
	c[0] = 2; c[1] = 1; c[2] = 0;
	
	try
	{
		C_lp p(A,b,c);
		//p.print();
		p.simplex();
		p.print_results();
	}
	catch(C_lp_error anError)
	{
		cout << anError.what() << endl;
	}





	C_matrix A(3,3);
	C_vector b(3);
	C_vector c(3);
	
	A[0][0] = 2; A[0][1] = -1; A[0][2] = 2;
	A[1][0] = 2; A[1][1] = -3; A[1][2] = 1;
	A[2][0] = -1; A[2][1] = 1; A[2][2] = -2;
	
	b[0] = 4;
	b[1] = -5;
	b[2] = -1;
	
	c[0] = 1; c[1] = -1; c[2] = 1;
	
	try
	{
		C_lp p(A,b,c);
		//p.print();
		p.simplex();
		p.print_results();
	}
	catch(C_lp_error anError)
	{
		cout << anError.what() << endl;
	}
	








	
	vector<vector<int> >v(4,4);
	v[0][0] = 11; v[0][1] = 12; v[0][2] = 13; v[0][3] = 14;
	v[1][0] = 21; v[1][1] = 22; v[1][2] = 23; v[1][3] = 24;
	v[2][0] = 31; v[2][1] = 32; v[2][2] = 33; v[2][3] = 34;
	v[3][0] = 41; v[3][1] = 42; v[3][2] = 43; v[3][3] = 44;

	for(int i(0); i < v.size(); i++)
	{
		for(int j(0); j < v[0].size(); j++)
		{
			cout << v[i][j] << '\t' << '\t';
		}
		cout << endl;
	}
	cout << endl;

	for(int i(0); i < v.size(); i++)
	{
		v[i].erase(v[i].begin() + 2);
	}
	

	
	for(int i(0); i < v.size(); i++)
	{
		for(int j(0); j < v[0].size(); j++)
		{
			cout << v[i][j] << '\t' << '\t';
		}
		cout << endl;
	}
	cout << endl;



	C_subset J1(7,67);
	C_subset J2(7,96);
	C_subset J3(7,76);
	C_subset J4(7,98);
	C_subset J5(7,112);
	
	C_subsets S1;
	S1.push_back(J1);
	S1.push_back(J2);
	
	C_subsets S2;
	S2.push_back(J3);
	S2.push_back(J4);
	
	C_subsets S3;
	S3.push_back(J5);
	
	
	c7.N.initialize(c7.size);
	bool test = c7.realize(S1);
	cout << test << endl << endl << endl;
	
	//c7.N.initialize(c7.size);
	//test = c7.realize(S2);
	//cout << test << endl << endl << endl;
	
	//c7.N.initialize(c7.size);
	//test = c7.realize(S3);
	//cout << test << endl << endl << endl;
	
	//c7.realization();
	//cout << endl << "Number of not realized  " << c7.not_realized.size() << endl;




	
	
	
	
	C_matrix A(2,3);
	A[0][0] = 1;
	A[0][1] = 2;
	A[0][2] = 1;
	A[1][0] = 3;
	A[1][1] = -2;
	A[1][2] = 3;

	C_vector b(2);
	b[0] = 5;
	b[1] = 2;
	
	C_vector c(3);
	c[0] = 2;
	c[1] = 1;
	c[2] = 0;

	C_lp p1(A,b,c);
	cout << "Initial state" << endl;
	p1.print();
	p1.simplex();
		






C_matrix AA(2,2);
	AA[0][0] = 1;
	AA[0][1] = 1;
	AA[1][0] = 1;
	AA[1][1] = 2;

	C_vector bb(2);
	bb[0] = 8;
	bb[1] = 7;

	C_vector cc(2);
	cc[0] = 1;
	cc[1] = 1;

	C_lp p2(AA,bb,cc);
	p2.simplex();
		








	C_lp p1;
	
	C_vector v(3);

	v[0] = 0;
	v[1] = -5;
	v[2] = -8;	
	p1.tableau.push_back(v);

	v[0] = 2;
	v[1] = 1;
	v[2] = 1;	
	p1.tableau.push_back(v);
	
	v[0] = 0;
	v[1] = 1;
	v[2] = -2;	
	p1.tableau.push_back(v);
	
	v[0] = 1;
	v[1] = -1;
	v[2] = 4;	
	p1.tableau.push_back(v);
	
	//float* t = max_element(p1.tableau[1].begin(), p1.tableau[1].end());
	//cout << endl << *t << endl << endl;

	p1.N = 5;
	p1.M = 3;
	p1.base.push_back(3);
	p1.base.push_back(4);
	p1.base.push_back(5);
	p1.non_base.push_back(1);
	p1.non_base.push_back(2);
	
	//p1.print();
	
	p1.simplex();
	
	//p1.print();




	p1.pivot_line = 3;
	p1.pivot_column = 2;
	p1.pivot();
	
	p1.print();
	
	p1.pivot_line = 2;
	p1.pivot_column = 1;
	p1.pivot();
	
	p1.print();
	
		


	C_cuts c5(5);
	C_cuts c6(6);
	C_cuts c7(7);
	C_cuts c8(8);
	C_cuts c9(9);
	C_cuts c10(10);
	
	
	//c5.generate();
	//cout << "Number of elements in C5:  " << c5.nbElements() << endl;
	//cout << c5 << endl << endl;

	//c6.generate();
	//cout << "Number of elements in C6:  " << c6.nbElements() << endl;
	//cout << c6 << endl << endl;
	
	//c7.generate();
	//cout << "Number of elements in C7:  " << c7.nbElements() << endl;
	//cout << c7 << endl << endl;

	//c8.generate();
	//cout << "Number of elements in C8:  " << c8.nbElements() << endl;
	//cout << c8 << endl << endl;
	
	//c9.generate();
	//cout << "Number of elements in C9:  " << c9.nbElements() << endl;
	//cout << c9 << endl << endl;

	//c10.generate();
	//cout << "Number of elements in C10:  " << c10.nbElements() << endl;
	//cout << c10 << endl << endl;





	C_subsets::const_iterator j,jj;
	C_cuts::const_iterator i = C5.begin();
	C_cuts::const_iterator ii = C5.end();
	while(i != ii)
	{
		j = (*i).begin();
		jj = (*i).end();
		while(j != jj)
		{
			cout << (*j).code << endl;
			j++;
		}
		cout << "-------------" << endl << endl;
		i++;
	}
*/
